当前位置:首页 > 开发 > 编程语言 > 编程 > 正文

Junit测试的抛出异常基础实例

发表于: 2013-10-09   作者:alleni123   来源:转载   浏览次数:
摘要: public class Calculator { public int divide(int a, int b) throws Exception{ if(0==b){ throw new Exception("除数不能为0"); } return a/b; } } 这里我们在CalculatorTest里面要测试
public class Calculator
{	
   	public int divide(int a, int b) throws Exception{
		if(0==b){
			throw new Exception("除数不能为0");
		}
		 
		return a/b;
	}
}


这里我们在CalculatorTest里面要测试这个异常的抛出。

        @Test
	public void testDivideByZero(){
		 
	 	  Throwable th=null;
			try
			{
				cal.divide(4, 0);
				fail();
			}
			catch (Exception e)
			{	
				th=e;
				e.printStackTrace();
				 
			
			}
	 
		
		
	 	assertEquals(Exception.class, th.getClass()); 
	 	assertEquals("除数不能为0", th.getMessage());
	 	
		 
	}


在这里声明一个Throwable类的对象th, 由于Throwable是Exception的父类,所以在catch语句中, 我们可以将th指向e的引用。
最后测试Exception.class和th.getClass()是否是同一个运行中的类,
然后测试message是否相同。

这个是junit3的测试方法。 junit4就特别简单了。
通过注释的方法
@Test(expected=Exception.class)
然后去掉try/catch那一堆, 就可以了。

Junit测试的抛出异常基础实例

  • 0

    开心

    开心

  • 0

    板砖

    板砖

  • 0

    感动

    感动

  • 0

    有用

    有用

  • 0

    疑问

    疑问

  • 0

    难过

    难过

  • 0

    无聊

    无聊

  • 0

    震惊

    震惊

编辑推荐
异常如下: Caused by: java.lang.NoSuchMethodError: net.sf.ehcache.Cache.<init>(Ljava/lan
JUnit基础及第一个单元测试实例(JUnit3.8) 单元测试   单元测试(unit testing) ,是指对软件
本文主要介绍了如何使用 JUnit 4 提供的各种功能开展有效的单元测试,并通过一个实例演示了如何使用
我所用的开发工具是Myeclipse 1,配置Junit File------properties------如图 2,<img height="49
JUnit 4 使用 Java 5 中的注解(annotation),以下是JUnit 4 常用的几个 annotation 介绍 @Before
需要在工程中引入junit的jar包,测试sum方法的返回值是否正确,代码如下: package com.channelsoft
junit实例教程 2008-08-06 09:25 1、概述   Junit测试是程序员测试,即所谓白盒测试,因为程序员
1 junit测试用例代码 package junitTest; import static org.junit.Assert.*; import org.junit.Aft
package creeper; import java.util.Scanner; public class size { private static int intercePosi
一、题目简介 返回一个给定整数参数的绝对值。 二、源码的github链接 https://github.com/liyan9410
版权所有 IT知识库 CopyRight © 2009-2015 IT知识库 IT610.com , All Rights Reserved. 京ICP备09083238号